﻿using UnityEditor;
using UnityEngine;
using System.Collections;

public class StageGenerator : EditorWindow {
	public GameObject obj;

	[MenuItem("Juggalo Tools/Generate Stage")]
	public static void GenerateStage() {
		StageHandler stageHandler = GameObject.Find("StageHandler").GetComponent<StageHandler>();
		stageHandler.CreateTiles();
	}

	[MenuItem("Juggalo Tools/Add Object")]
	public static void AddObject() {
		EditorWindow.GetWindow(typeof(StageGenerator)).Show();
	}

	[MenuItem("Juggalo Tools/ResetToDay")]
	public static void ResetMaterials() {
		GameObject.Find("TimeManager").GetComponent<TimeManager>().ResetMaterials();
	}

	void OnGUI() {
		EditorGUILayout.Space();
		EditorGUILayout.Space();

		obj = EditorGUILayout.ObjectField("Prefab:", obj, typeof(GameObject), false) as GameObject;

		if(GUILayout.Button("Add Object")) {
			StageHandler stageHandler = GameObject.Find("StageHandler").GetComponent<StageHandler>();

			foreach(GameObject tileObj in Selection.gameObjects) {
				StageTile tile = tileObj.GetComponent<StageTile>();
				Vector3 tilePos = tile.transform.position;
				GameObject objInstance = GameObject.Instantiate(obj, new Vector3(tilePos.x, tilePos.y, -1.5f), Quaternion.identity) as GameObject;
				Ghost ghost = objInstance.GetComponent<Ghost>();

				if(ghost) {
					ghost.currentTile = tile;
					ghost.stageHandler = stageHandler;
				}

				if(obj.name == "Wall") {
					tile.locked = true;
				}
			}
		}
	}
}
