﻿using UnityEngine;
using System.Collections;

public class EndPoint : MonoBehaviour {
	public string targetScene;
	public bool locked;
	public GameObject lockMark;

	void OnTriggerEnter(Collider other) {
		if(other.gameObject.GetComponent<Character>()) {
			if(this.locked) {
				this.lockMark.SetActive(true);
			}
			else {
				StageHandler.home = true;
				StageHandler.PlayClip((AudioClip)Resources.Load("Audio/finish level"));
				this.GetComponent<tk2dSprite>().SetSprite("house_open");
				iTween.CameraFadeAdd();
				Hashtable ht = new Hashtable();
				ht.Add("amount", 1.0f);
				ht.Add("time", 3.0f);
				ht.Add("oncomplete", "GoToNextScene");
				ht.Add("oncompletetarget", this.gameObject);
				iTween.CameraFadeTo(ht);
			}
		}
	}

	void OnTriggerExit(Collider other) {
		if(other.gameObject.GetComponent<Character>() && this.locked) {
			this.lockMark.SetActive(false);
		}
	}

	public void GoToNextScene() {
		Application.LoadLevel(this.targetScene);
	}

	public void Unlock() {
		this.locked = false;
	}
}
