﻿using UnityEngine;
using System.Collections;

public class Quicksand : MonoBehaviour {
	public StageHandler stageHandler;
	public tk2dSprite sprite;
	public float maxScale;
	public float scaleSpeed;

	void Awake() {
		this.stageHandler = GameObject.Find("StageHandler").GetComponent<StageHandler>();
		this.sprite = GetComponent<tk2dSprite>();
	}

	// Use this for initialization
	void Start() {
		ScaleUp();
	}
	
	// Update is called once per frame
	void Update() {
	
	}

	public void UpdateScale(Vector2 bounds) {
		this.sprite.scale = new Vector3(bounds.x, bounds.y, this.transform.localScale.z);
	}

	private void ScaleUp() {
		Hashtable ht = new Hashtable();
		ht.Add("from", new Vector2(0, 0));
		ht.Add("to", new Vector2(this.maxScale, this.maxScale));
		ht.Add("time", this.scaleSpeed);
		ht.Add("onupdate", "UpdateScale");
		ht.Add("oncomplete", "ScaleDown");
		iTween.ValueTo(this.gameObject, ht);
	}

	private void ScaleDown() {
		Hashtable ht = new Hashtable();
		ht.Add("from", new Vector2(this.maxScale, this.maxScale));
		ht.Add("to", new Vector2(0, 0));
		ht.Add("time", this.scaleSpeed);
		ht.Add("onupdate", "UpdateScale");
		ht.Add("oncomplete", "ScaleUp");
		iTween.ValueTo(this.gameObject, ht);
	}

	void OnTriggerEnter(Collider other) {
		if(StageHandler.home) {
			return;
		}

		Character character = other.gameObject.GetComponent<Character>();
		
		if(character) {
			this.stageHandler.char1.dead = true;
			this.stageHandler.char2.dead = true;
			iTween.CameraFadeAdd();
			Hashtable ht = new Hashtable();
			ht.Add("amount", 1.0f);
			ht.Add("time", 3.0f);
			ht.Add("oncomplete", "ResetScene");
			ht.Add("oncompletetarget", this.gameObject);
			iTween.CameraFadeTo(ht);
		}
	}

	public void ResetScene() {
		Application.LoadLevel(this.stageHandler.currentScene);
	}
}
